<?php
defined( '_VALID' ) or die( 'Restricted access' );
/*
UTF8 code for punctuation mark characters
(space) ! " # $ % & ' ( ) * + , - . : ; < = > ? @
32...46
58...64

UTF8 code for numeric characters
48...57 '0-9'

UTF8 code for english characters
65...90 'A-Z'
97...122 'a-z'

UTF8 code for farsi characters
'آابپتثجچحخدذرزژسشصضطظعغفقکگلمنوهی'
216 161...186 'ء'...'غ'
217 129...138 'ف'...'ي'
216 140 '،'
216 155 '؛'
216 159 '?'
217 190 'پ'
218 134 'چ'
218 152 'ژ'
218 169 'ک'
218 175 'گ'
219 140 'ی'
*/
class wordfilter {
	var $dictionary = '.';
	
	function FindValidWord($str,&$stroffset=0,$phas=1,&$flag=0){
	  $ValidWord='';
	  for ($i=$stroffset ;$str[$i]!=''; $i++) {
		  $ascii1=ord($str[$i]);
		  $ascii2=ord($str[$i+1]);
		  //if 0...9 char
		  if($ascii1>=48 && $ascii1<=57)$ValidWord.= $str[$i];
		  //convert A...Z to a...z char
		  elseif($ascii1>=65 && $ascii1<=90)$ValidWord.= chr($ascii1+32);
		  //if a...z char
		  elseif($ascii1>=97 && $ascii1<=122)$ValidWord.= $str[$i];
		  elseif($ascii1==216)
		  {
			  //if 'ء'...'غ' char
			  if($ascii2>=161 && $ascii2<=186){$ValidWord.= $str[$i].$str[$i+1];$i++;continue;}
			  //if be ، ؛ ؟ char
			  elseif($phas==2 && ($ascii2==140 || $ascii2==155 || $ascii2==159)){$i++;$flag=3;break;}
		  }
		  elseif($ascii1==217)
		  {
			  //if 'ف'...'ي' char
			  if($ascii2>=129 && $ascii2<=138){$ValidWord.= $str[$i].$str[$i+1];$i++;continue;}
			  //if 'پ' char
			  elseif($ascii2==190){$ValidWord.= $str[$i].$str[$i+1];$i++;continue;}
		  }
		  elseif($ascii1==218)
		  {
			  //if 'چ ژ گ' char
			  if($ascii2==134 || $ascii2==152 || $ascii2==175){$ValidWord.= $str[$i].$str[$i+1];$i++;continue;}
			  //convert 'ک' to 'ك' char
			  elseif($ascii2==169){$ValidWord.= chr(217).chr(131);$i++;continue;}
		  }
		  //convert 'ی' to 'ي' char
		  elseif($ascii1==219 && $ascii2==140){$ValidWord.= chr(217).chr(138);$i++;continue;}
		  //in phas 1 if be (space) char then valid word find 
		  elseif($phas==1 && $ascii1==32){$i++;break;}
		  //in phas 2
		  elseif($phas==2)
		  {
			  //if be ! " # $ % & ' ( ) * + , - . : ; < = > ? @ char then valid word find 
			  if(($ascii1>32 && $ascii1<=46) || ($ascii1>=58 && $ascii1<=64))$flag=3;
			  //if be (space) char then valid word find 
			  elseif($ascii1==32){if($flag==2)$flag=0;elseif($flag==3)$flag=2;}
			  $i++;break;
		  }
		  //in phas 0 if be , char then valid word find 
		  elseif($phas==0 && $ascii1==44){$i++;break;}
		  //if be other char
		  else{}
	  }
	  $stroffset=$i;
	  return $ValidWord;
	}
	
	function TrimWordFound($string){
	//if come after char same char then delete that
	//i.e wwword to word 
	  for ($i=0 ;$string[$i]!=''; $i++) {
		  $ascii1=ord($string[$i]);
		  if($ascii1>=48 && $ascii1<=122)
		  {
			  $ascii2=ord($string[$i+1]);
			  if($ascii1==$ascii2){$string[$i]=' ';}
		  }
		  else
		  {
			  $ascii2=ord($string[$i+2]);
			  if($ascii2>=48 && $ascii2<=122) continue;
			  if($ascii1==$ascii2)
			  {
				  if(ord($string[$i+1])==ord($string[$i+3])){$string[$i]=' ';$string[$i+1]=' ';$i++;}
			  }
		  }
	  }
	  return preg_replace('/\s+/','',$string);
	}
	
	function filter($string)
	{
		global $Config_use_wordfilter;
		if ($Config_use_wordfilter=='0') return false;
	  $dictionary=preg_replace('/^[﻿]/', '',file_get_contents($this->dictionary));
	  $dic=array();
	// PHAS 1
		  $words=array();
		  $stroffset=0;
		  $i=0;
		  while($string[$stroffset]!='')
		  {
			  $word = $this->FindValidWord($string,$stroffset);
			  if(!$word)continue;
			  $trimword = $this->TrimWordFound($word);
			  $words[] = $trimword;
			  $trimword_len= strlen($trimword);
			  $pattern= '/(?:^|(?<=,))[^,]{'.$trimword_len.'}(?:(?=,)|$)/';
			  $num_dic= preg_match_all($pattern,$dictionary,$dic);
			  for ( $j=0 ; $j<$num_dic ; $j++ ){if (strcmp($words[$i],$dic[0][$j])==0) return true;}
			  $i++;
		  }
	// PHAS 2
		  $num_words=0;
		  $words=array();
		  $stroffset=0;
		  $i=0;
		  $flag=0;
		  while($string[$stroffset]!='')
		  {
			  $word = $this->FindValidWord($string,$stroffset,2,$flag);
			  if(!$word)continue;
			  $trimword = $this->TrimWordFound($word);
			  $words[] = $trimword;
			  $num_words++;
			  if($flag==0)continue;
			  $trimword_len= strlen($trimword);
			  $pattern= '/(?:^|(?<=,))[^,]{'.$trimword_len.'}(?:(?=,)|$)/';
			  $num_dic= preg_match_all($pattern,$dictionary,$dic);
			  for ( $j=0 ; $j<$num_dic ; $j++ ){if (strcmp($words[$i],$dic[0][$j])==0) return true;}
			  $i++;
		  }
	// PHAS 3
		  $temp=array();
		  $temp = $words;
		  $templen = $num_words-1;
		  for($i=0;$i<$num_words;$i++,$templen--){
			  for($j=0 ; $j<$templen ; $j++ ){
				  $temp[$j] .= $words[$i+$j+1];
				  $trimword = $this->TrimWordFound($temp[$j]);
				  $temp[$j] = $trimword;$num_words++;
				  $trimword_len= strlen($trimword);
				  $pattern= '/(?:^|(?<=,))[^,]{'.$trimword_len.'}(?:(?=,)|$)/';
				  $num_dic= preg_match_all($pattern,$dictionary,$dic);
				  for ( $k=0 ; $k<$num_dic ; $k++ ){if (strcmp($dic[0][$k],$temp[$j])==0) return true;}
			  }
		  }
	// END PROCESS
	// the word is not banned
	  return false;
	}
}
?>